uniform mat4 uMVPMatrix; //ܱ任
uniform mat4 uMMatrix; //任
uniform float aAlphaValue;//Ƭ͸ֵ
uniform vec3 uLightLocation;	//Դλ
uniform vec3 uCamera;	//λ
attribute vec3 aNormal;    //
attribute vec3 aPosition;  //λ
attribute vec2 aTexCoor;    //
varying vec2 vTextureCoord;  //ڴݸƬԪɫı
varying vec3 vPosition;		//ڴݸƬԪɫı
varying vec4 vAmbient;			//ڴݸƬԪɫĻǿ
varying vec4 vDiffuse;			//ڴݸƬԪɫɢǿ
varying vec4 vSpecular;			//ڴݸƬԪɫľǿ

void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=aPosition+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(aPosition,1)).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(aPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(aPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=30.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}

void main()  {                            		
   gl_Position = uMVPMatrix * vec4(aPosition,1); //ܱ任˴λƴ˶λ
   /*
   vec4 ambientTemp,diffuseTemp,specularTemp;	  //ͨǿȵı       
   pointLight(normalize(aNormal),ambientTemp,diffuseTemp,specularTemp,uLightLocation,
   vec4(0.15,0.15,0.15,1.0),vec4(0.8,0.8,0.8,1.0),vec4(0.7,0.7,0.7,1.0)); 
   vAmbient=ambientTemp; 		//ǿȴƬԪɫ
   vDiffuse=diffuseTemp; 		//ɢǿȴƬԪɫ
   vSpecular=specularTemp; 		//ǿȴƬԪɫ    
   */
   vTextureCoord = aTexCoor;	//յ괫ݸƬԪɫ
   vPosition = aPosition;
}                      